package com.safeway.epe.avrokafkawithoutschemaregistry.producer;

import com.safeway.epe.avrokafkawithoutschemaregistry.configuration.KafkaProperties;
import com.safeway.epe.avrokafkawithoutschemaregistry.promotion.GeneratePromotion;
import com.safeway.epe.model.Promotion;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.NetworkClient;
import org.apache.kafka.clients.producer.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import static com.safeway.epe.avrokafkawithoutschemaregistry.promotion.GeneratePromotion.convertTimestampToDateTime;

@Service
@Slf4j
public class PromotionProducer {
    @Autowired
    private KafkaProperties kafkaProperties;

    public Future<RecordMetadata> sendPromotionEvent(KafkaProducer<String, Promotion> producer) throws IOException, ExecutionException, InterruptedException {
        int setCount =0 ;
        Future<RecordMetadata> future = null;
        while(true) {
            Promotion promotion = GeneratePromotion.generatedPromotion();
                try {
                    future = producer.send(new ProducerRecord<String, Promotion>(kafkaProperties.getTopic(), promotion));
                    RecordMetadata metadata = future.get();
                    if (metadata.hasOffset() && metadata.hasTimestamp()) {
                        log.info("partition::" + metadata.partition() + "\t Offset::" + metadata.offset() + "\t timestamp::" + convertTimestampToDateTime(metadata.timestamp()));
                    } else {
                        throw new RuntimeException("Exception ::");
                    }
                    //producer.close();
                } catch (Exception e) {
                    log.error("Broker is down");
                }
            return future;
        }
    }
}
